import javax.naming.*;
import javax.naming.directory.*;

import java.util.Hashtable;

/**
 * Demonstrates how to read a binary attribute by adding to the
 * LDAP service provider's list of binary attributes.
 *
 * usage: java BinaryList
 */
class BinaryList {
    public static void main(String[] args) {

	// Set up environment for creating initial context
	Hashtable env = new Hashtable(11);
	env.put(Context.INITIAL_CONTEXT_FACTORY, 
	    "com.sun.jndi.ldap.LdapCtxFactory");
	env.put(Context.PROVIDER_URL, "ldap://localhost:389/o=JNDITutorial");

	env.put("java.naming.ldap.attributes.binary", "mpegvideo myspecialkey");

	try {
	    // Create initial context
	    DirContext ctx = new InitialDirContext(env);

	    // Get all attributes
	    Attributes attrs = ctx.getAttributes("cn=S. User, ou=NewHires");

	    // See what we got
	    Attribute attr = attrs.get("mySpecialKey");
	    if (attr != null) {
		Object val = attr.get();
		if (val instanceof String) {
		    System.out.println(val);
		} else {
		    byte[] buf = (byte[])val;
		    for (int i = 0; i < buf.length; i++) {
			System.out.print(Integer.toHexString(buf[i]) + " ");
		    }
		    System.out.println();
		}
	    }
	    // do something useful with ctx
	} catch (NamingException e) {
	    e.printStackTrace();
	}
    }
}
