import javax.naming.*;
import javax.naming.directory.*;

import java.util.Hashtable;

/**
 * Demonstrates how to create an initial context to an LDAP server
 * using LDAP version 3.
 *
 * usage: java Version 3
 */
class Version3 {
    public static void main(String[] args) {

	// Set up environment for creating initial context
	Hashtable env = new Hashtable(11);
	env.put(Context.INITIAL_CONTEXT_FACTORY, 
	    "com.sun.jndi.ldap.LdapCtxFactory");
	env.put(Context.PROVIDER_URL, "ldap://localhost:389/o=JNDITutorial");

	env.put("java.naming.version.ldap", "3");

	try {
	    // Create initial context
	    DirContext ctx = new InitialDirContext(env);

	    // ... do something useful with ctx
	    System.out.println(ctx.lookup("ou=People"));

	} catch (NamingException e) {
	    e.printStackTrace();
	}
    }
}
