import javax.naming.*;
import javax.naming.directory.*;
import java.util.Hashtable;

/**
  * Demonstrates how to look up an attribute syntax's schema given its name.
  *
  * usage: java LookupSyntax
  */
class LookupSyntax {
    public static void main(String[] args) {

	// Set up environment for creating initial context
	Hashtable env = new Hashtable(11);
	env.put(Context.INITIAL_CONTEXT_FACTORY, 
	    "com.sun.jndi.ldap.LdapCtxFactory");
	env.put(Context.PROVIDER_URL, "ldap://localhost:389/o=JNDITutorial");

	try {
	    // Create the initial context
	    DirContext ctx = new InitialDirContext(env);

	    // Get the schema tree root
	    DirContext schema = ctx.getSchema("");

	    // Get schema object for Directory String's syntax
	    DirContext dsSchema =
(DirContext)schema.lookup("SyntaxDefinition/1.3.6.1.4.1.1466.115.121.1.15");

	    // Get Directory String schema object's attributes
	    Attributes dsAttrs = dsSchema.getAttributes("");

	    System.out.println(dsAttrs);
	} catch (NamingException e) {
	    e.printStackTrace();
	}
    }
}
